zoukankan      html  css  js  c++  java
  • 最长上升子序列(LIS经典变型) dp学习~5

    题目连接:http://acm.hdu.edu.cn/showproblem.php?pid=1069

    Monkey and Banana

    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)
    Total Submission(s): 10875    Accepted Submission(s): 5660


    Problem Description
    A group of researchers are designing an experiment to test the IQ of a monkey. They will hang a banana at the roof of a building, and at the mean time, provide the monkey with some blocks. If the monkey is clever enough, it shall be able to reach the banana by placing one block on the top another to build a tower and climb up to get its favorite food.

    The researchers have n types of blocks, and an unlimited supply of blocks of each type. Each type-i block was a rectangular solid with linear dimensions (xi, yi, zi). A block could be reoriented so that any two of its three dimensions determined the dimensions of the base and the other dimension was the height. 

    They want to make sure that the tallest tower possible by stacking blocks can reach the roof. The problem is that, in building a tower, one block could only be placed on top of another block as long as the two base dimensions of the upper block were both strictly smaller than the corresponding base dimensions of the lower block because there has to be some space for the monkey to step on. This meant, for example, that blocks oriented to have equal-sized bases couldn't be stacked. 

    Your job is to write a program that determines the height of the tallest tower the monkey can build with a given set of blocks.
     


    Input
    The input file will contain one or more test cases. The first line of each test case contains an integer n,
    representing the number of different blocks in the following data set. The maximum value for n is 30.
    Each of the next n lines contains three integers representing the values xi, yi and zi.
    Input is terminated by a value of zero (0) for n.
     


    Output
    For each test case, print one line containing the case number (they are numbered sequentially starting from 1) and the height of the tallest possible tower in the format "Case case: maximum height = height".
     


    Sample Input
    1 10 20 30 2 6 8 10 5 5 5 7 1 1 1 2 2 2 3 3 3 4 4 4 5 5 5 6 6 6 7 7 7 5 31 41 59 26 53 58 97 93 23 84 62 64 33 83 27 0
     


    Sample Output
    Case 1: maximum height = 40 Case 2: maximum height = 21 Case 3: maximum height = 28 Case 4: maximum height = 342
    题意:
    题目:给出一些长方体,然后让你把他堆成塔,
    要求下面的塔的要比上面的塔大(长和宽),
    而且每一种长方体的数量都是无限的。
    每个格子最多3个状态,也就是高最多有3种,也就是一共有N*3 最多90个格子,但是X和Y可以对调,那么就最多180个,我对180个格子对X从小到大排序,X相等,Y就重小到大排序,那么这个问题就可以转换成类似求最大递增子序列问题一样思路的DP,DP[i]表示第i个格子时的最大值,dp[i+1]就是从前i个中找符合条件的最大的一个加上去,因为,重楼必须X越来越小,反过来就是X越来越大,我已经保证了X是递增的,所以这样DP是对的!
     1 #include<cstdio>
     2 #include<cstring>
     3 #include<algorithm>
     4 using namespace std;
     5 const int N = 200;
     6 
     7 struct Node {
     8     int x;
     9     int y;
    10     int z;
    11     bool operator < (const Node &a) const 
    12     {
    13         if(x!=a.x) return x < a.x;
    14         else if(y!=a.y) return y < a.y;
    15         else return z > a.z;
    16     }
    17 } node[N];
    18 int dp[N];
    19 
    20 int main()
    21 {
    22     int n;
    23     int cnt = 1;
    24     while(~scanf("%d",&n))
    25     {
    26         if(n==0) return 0;
    27         memset(dp,0,sizeof(dp));
    28         int x,y,z;
    29         int t = 0;
    30         for(int i = 0; i < n; i++){
    31             scanf("%d%d%d",&x,&y,&z);
    32             node[t].x = x;
    33             node[t].y = y;
    34             node[t].z = z;
    35             t++;
    36             node[t].x = x;
    37             node[t].y = z;
    38             node[t].z = y;
    39             t++;
    40             node[t].x = y;
    41             node[t].y = x;
    42             node[t].z = z;
    43             t++;
    44             node[t].x = y;
    45             node[t].y = z;
    46             node[t].z = x;
    47             t++;
    48             node[t].x = z;
    49             node[t].y = x;
    50             node[t].z = y;
    51             t++;
    52             node[t].x = z;
    53             node[t].y = y;
    54             node[t].z = x;
    55             t++;
    56         }
    57         sort(node,node+6*n);
    58         int mmax = 0;
    59         for(int i = 0; i < 6*n; i++)
    60             dp[i] = node[i].z;
    61         for(int i = 0; i < 6*n; i++)
    62         {
    63             for(int j = 0; j < i; j++)
    64             {
    65                 if((node[i].x>node[j].x)&&(node[i].y>node[j].y))
    66                     dp[i] = max(dp[i],dp[j]+node[i].z);
    67             }
    68             mmax = max(mmax,dp[i]);
    69         }
    70         printf("Case %d: maximum height = ",cnt);
    71         cnt++;
    72         printf("%d
    ",mmax);
    73     }
    74     return 0;
    75 }
  • 相关阅读:
    echarts数据包坐标拾取工具
    JS 多个条件判断
    js 实现各浏览器全屏
    前端统计使用插件
    JS 随机排序算法
    js中布尔值为false的六种情况
    Mosaic
    单点登录
    JavaScript数据结构和算法
    一个普通函数的冷僻属性(length、caller、arguments、name、[[Scopes]]和[[FunctionLocation]])
  • 原文地址:https://www.cnblogs.com/shanyr/p/5255734.html
Copyright © 2011-2022 走看看